import socket
import threading
import re 

client_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
stop_event = threading.Event()
host = "147.185.221.19"
port = 42439

last_sent_message = None

def extract_message_content(full_message):
    match = re.match(r"^.*?:\s*(.*)$", full_message)
    if match:
        return match.group(1)
    return full_message

def receive_messages():
    global last_sent_message
    while not stop_event.is_set():
        try:
            message = client_socket.recv(1024).decode('utf-8').strip()
            if not message:
                break

            message_content = extract_message_content(message)

            if message_content != last_sent_message:
                print(message)
            else:
                last_sent_message = None
        except Exception as e:
            if not stop_event.is_set():
                print("Ошибка при получении сообщения: " + str(e))
            break

def start_receiving_thread():
    receive_thread = threading.Thread(target=receive_messages, daemon=True)
    receive_thread.start()

try:
    client_socket.connect((host, port))
    start_receiving_thread()
except Exception as e:
    print("Ошибка подключения: " + str(e))

while True:
    msg = input()
    last_sent_message = msg 
    client_socket.send(msg.encode('utf-8'))
